
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>OSG开发概览 / iVAN</title>

    <meta name="description" content="OSG开发概览 1 OSG基础知识 Ø OSG是Open Scene Graphic 的缩写,OSG于1997年诞生于以为滑翔机爱好者之手,Don burns  为了对滑翔机的飞行进行模拟,对openGL的库进行了封装,osg的雏形就这样诞生了,1998年Don burns 遇到了同样喜欢滑翔机和计算机图形学的Robert Osfield ,从此Robert Osfield加入了osg小组的开发并一直担任开发小组的组长. Ø OSG不但有openGL的跨平台的特性和较高的渲染性能,还提供了一系列可供3D程序开发">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">OSG开发概览</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>1 OSG基础知识</h1>
<p>Ø OSG是Open Scene Graphic 的缩写，OSG于1997年诞生于以为滑翔机爱好者之手，Don burns  为了对滑翔机的飞行进行模拟，对openGL的库进行了封装，osg的雏形就这样诞生了，1998年Don burns 遇到了同样喜欢滑翔机和计算机图形学的Robert Osfield ，从此Robert Osfield加入了osg小组的开发并一直担任开发小组的组长。</p>
<p>Ø OSG不但有openGL的跨平台的特性和较高的渲染性能，还提供了一系列可供3D程序开发者使用的功能接口，包括2D和3D数据文件的加载、纹理字体支持、细节层次（LOD）控制、多线程数据分页处理等。OSG广泛应用于飞行仿真等领域，包括Flightgear，及美国军方投资的仿真项目Delta3d等</p>
<h2>1.1 计算机绘图的基本知识</h2>
<p>Ø 首先要先回顾一下，在显示世界中，我们是如何作画的。</p>
<p>Ø 在现实世界中，绘制一副画，我们需要的东西就是彩笔、白纸。通过选择不同颜色的彩笔，在白纸上移动，就可以将白纸上的不同的点描绘上不同的颜色，而所有这些点连接起来，从人的宏观视野看来，就构成了一副对人有意义的画作。</p>
<p>Ø 类比到计算机的实际中来。在计算机的世界里。作画的过程又是怎样的呢？</p>
<p>Ø 同样，绘制虚拟的图像，也需要“彩笔”和“白纸”。在计算机的世界里，“彩笔”就是Direct3D之类的绘图API函数，而“白纸”就是存储数据的内存。我们在内存中划分出一块区域，其中的数据就是对一个真实世界的模拟。一个数据就描述真实世界中一个点的属性。在我们作画前，他们都只有一个初始值，就像白纸在作画前只有白色一样。而在作画后，每一个数据都有了独特的意义，将整片数据连接在一起看，就是一副有意义的图景。作画的过程就是对内存中的每一个数据进行赋值的过程，相当于用彩笔给白纸上的一个点进行着色。选择不同的API函数，可以画出不同的形状。</p>
<h2>1.2 OSG程序框架</h2>
<p>Ø 一个最简单的OSG程序如下所示，当然在如果是在VS下面进行编辑的话要进行一些设置，要设置OSG的lib和include目录。</p>
<pre><code> 1 #include&lt;osgDB/ReadFile&gt;
 2
 3 #include&lt;osgViewer/Viewer&gt;
 4
 5  void main()
 6
 7 {
 8
 9 osgViewer::Viewer viewer;
10
11 viewer.setSceneData(osgDB::readNodeFile("glider.osg"));
12
13 viewer.realize();
14
15 viewer.run();
16
17 }
18  </code></pre>
<p>osgViewer::Viewer viewer 申请了一个viewer，可以理解为申请一个观察器，该观察可以查看模型</p>
<p>viewer.setSceneData(osgDB::readNodeFile("glider.osg")) 这里是设置观察器Viewer中的数据，换句话说，有了观察器，就可以添加模型了</p>
<p>viewer.realize() 这个语句表达的意思非常多，事实上可以定位到Viewer.cpp的realize函数，会发现里面的操作非常多，可以理解为这是在渲染前的最后一步，会检查和设置图形上下文，屏幕啊什么的，会让你以前的设置，对Viewer的设置都生效。</p>
<p>viewer.run(); 这一句的意思就是渲染了，如果要解释它的意思的话，可以用下面的几个语句来替代：</p>
<p>while(!viewer.done()){viewer.frame();}.意思也就是说，只要viewer没有结束，那么就绘制它的每一个帧［frame］。</p>
<h2>1.3 OSG简单模型控制</h2>
<h3>1.3.1 添加模型</h3>
<p>在OSG当中模型是使用osg::Group和osg::Node来装载在一起的，比如同时需要加入两个模型，模型A了模型B，AB各自是一个NODE，那么可以使用以下语句来做到，首先使用一个Group,然后Group-&gt;addChild(A),同样，之后要Group-&gt;addChild(B)。然后再把Group添加到viewer当中就可以了。如图3.1所示AB之间的关系。在这里要申明的是NODE是Group的父类，在类中都有相应的方法可以转到对方，故Node与Group</p>
<p>是通用的，Node也可以被当作Group来用。</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL3hNQTR4LnBuZw==.jpg"></p>
<p> </p>
<p>图 31 AB都加入到Group当中</p>
<p>简单示例代码如下：</p>
<pre><code>1 #include&lt;osgDB/ReadFile&gt;
 2
 3 #include&lt;osgViewer/Viewer&gt;
 4
 5 #include&lt;osg/Node&gt;
 6
 7  void main()
 8
 9 {
10
11 osgViewer::Viewer viewer;
12
13 osg::Group * root=new osg::Group();
14
15 root-&gt;addChild(osgDB::readNodeFile("glider.osg"));
16
17 root-&gt;addChild(osgDB::readNodeFile("osgcool.osg"));
18
19 viewer.setSceneData(root);
20
21 viewer.realize();
22
23 viewer.run();
24
25 }
26  </code></pre>
<p>则运行结果为：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL0JnNGMwLnBuZw==.jpg"></p>
<p>图 32示例运行结果</p>
<h3>1.3.2 删除结点</h3>
<p>如果我们不需要某个结点了，比如图3.2我们看那个小飞机很不爽，我们想把它从场景中删除掉。不知道于某种目的，反正现在要删除掉，可能是开始想看见它现在不想看见它了。可以通过removeChild方法，除多个孩子也可以通过removeChildren方法，里面的参数有些需要索引值，有些需要结点本身的指针，读者可以自己尝试。这里要注意的是，如果要删除一个结点，那么该结点下的所有结点都会被删除。如果一个结点被加入到一个组中两次，那么这两次是分别存在的，删除一次还有另一次。删除操作不能说不是个危险的操作，有些时候，尤其在有移动结点等等混在一起时，删除操作有时候会发生一些比较奇怪的现象。在内存映象当中，如果一个模型被读取一次，而用了多次，那么所占用的空间是不会改变的。</p>
<h3>1.3.3 隐藏模型与结点开关</h3>
<p>Ø 隐藏模型</p>
<p>   隐藏模型其实模型仍在渲染当中，因此损耗并未减少，只不过隐藏了而已，隐藏的确不是个什么好操作，但是有时候对小模型确实也很实用。node-&gt;setNodeMask可以设置隐藏与显示。</p>
<p>Ø 节点开关</p>
<p>在OSG当中，专门有一个类来负责打开与关闭结点，该类名为osg::Switch，里面有相应的方法来控制它所管理的结点的打开与关闭。</p>
<p>两个方法都能控制模型的显示和隐藏，区别在于隐藏模型方法不会让模型在内存中消失，这样对于小的物体频繁的调用会节省一些时间，而对于有些大的模块在用一次以后可能很久再用第二次，这个时候用节点开关可以将模型销毁，再次使用再调入内存，以防止占用更多的资源。</p>
<h3>1.3.4 超级指针</h3>
<p>超级指针的机制，其实就是引用一个计数器，这个计数器会计算这个箱子被引用的次数，被别人引用一次这个计数器增加一，别人不用一次，即：释放一次，则计数器减一。当减至0时，内存放掉不用。</p>
<p>们来看使用一个Node的三种方法,对比一下：</p>
<p>Ø //方法一，最好的方法,十分安全，也是OSG中最常用的方法，多少版本它都没变</p>
<p>osg::ref_ptr&lt;osg::Node&gt;aNode(new osg::Node());</p>
<p>group-&gt;addChild(aNode.get());</p>
<p>Ø //方法二，也是非常好的方法，有时候不适用，但也十分安全</p>
<p>group-&gt;addChild(new osg::Node());</p>
<p>Ø //方法三，非常危险，但是令许多人无故铤而走险的方法</p>
<p>osg::Node*anotherNode=new osg::Node();</p>
<p>group-&gt;addChild(anotherNode);</p>
<p>方法一：在new::Node()时申请了一个Node的资源，这时在堆内引用该Node的计算器会被置1。在group-&gt;addChild(aNode.get())时又引用了一次，会再加1。在这两次引用都结束时，Node的资源就会被释放。</p>
<p>方法二：这个方法也是很实用的，但是无法引出Node的指针，也许在别处可以用到，事实上会经常用到。如果已经这样做了，得到Node指针也不是不可以的，可以使用NodeVisitor来得到Node的指针，也可以使用findChild方法来做这件事。</p>
<p>方法三：这个应该是最常用，但是最烂的方法了，原因在于如果在osg::Node*antherode=new osg::Node()之后发生了错误，抛出了异常，谁来释放Node所占用的资源呢。而这个异常在后面被捕获，程序正常的走下去，而内存却没有被正常的放掉。</p>
<h3>1.3.5 移动/旋转/缩放模型</h3>
<p>移动/旋转/缩放其实都是对矩阵进行操作，在OSG当中，矩阵可以当作一个特殊的结点加入到root当中，而矩阵下也可以另入结点，而加入的结点就会被这个矩阵处理过，比如移动过/旋转过/缩放过。在OSG中控制矩阵的类为osg::MatrixTransform。</p>
<p>Ø 移动</p>
<p>osg::Matrix::translate</p>
<p>Ø 旋转</p>
<p>osg::Matrix::rotate</p>
<p>Ø 缩放</p>
<p>osg::Matrix::scale</p>
<h2>1.4 基本几何图元</h2>
<h3>1.4.1 基本绘制方法</h3>
<p>首先来看一些OSG中的最基本的绘制路数。如果我们要绘制一个正方形，绘制有色彩，未贴图。首先我们必须要申请一个osg::Geometry,把这个Geometry加入到Geode就可以了。在这个Geometry中要设置一些元素，最基本的是顶点Vertex,颜色color,以及顶点的关联方式和法线normal.就可以了。如图3.3所示。</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL3lpcHFlLnBuZw==.jpg"></p>
<p> </p>
<p>图 33几何体绘制过程</p>
<h3>1.4.2 可绘制的图元</h3>
<p>所有可绘制的图元包括：</p>
<p>Ø POINTS[点]</p>
<p>Ø LINES[线]</p>
<p>Ø LINE_STRIP[线带]</p>
<p>Ø LINE_LOOP[闭合线段]</p>
<p>Ø TRIANGLES[三角形]</p>
<p>Ø TRIANGLE_STRIP[三角带]</p>
<p>Ø TRIANGLE_FAN[三角扇]</p>
<p>Ø QUADS[四方块]</p>
<p>Ø QUAD_STRIP[四方块带]</p>
<p>Ø POLYGON[多边形]</p>
<p>在OSG中设置直线线宽的专门有一个函数来管理，叫做LineWidth，它本身属于状态与属性类别中的类。事实上也是从那里派生而来。所有设置状态的操作都与此类似。</p>
<h3>1.4.3 内置几何类型</h3>
<p>如同OpenGL一样，OSG同样有一套内置几何类型，这些几何类型都在类osg::Shape中，这些shape本身都可以本当成一个Draw结点加入到geode中，然后再人geode中添加到root里进行渲染。形状共有九种，分别为：osg::Box[盒子]，osg::Capsule[胶囊形]，osg::CompositeShape[组合型]，osg::Cone[圆锥形]，osg::Cylinder[圆柱形]，osg::HeightField[高程形]，osg::InfinitePlane[有限面]，osg::Sphere[球形]，osg::TriangleMesh[三角蒙皮]。</p>
<p>内置几何类型的渲染过程,如图4.5所示</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL1RNQ29GLnBuZw==.jpg"></p>
<p> </p>
<p>图 34基本几何图元的添加过程</p>
<p>这里要注意的是，一般的形状态都有特定的因素，比如Box有长宽，圆有半径，以及各个图形所画的精细度都需要指明，这些精细度在球这样的形状上意义还是十分巨大的。在OSG中有专门指明精细度的类，名为：osg::TessellationHints。以球为例，只需要规定，圆心，半径和精细度就可以画出该球。</p>
<h2>1.5 交互</h2>
<h3>1.5.1 交互过程</h3>
<p>viewer的主要的功能是控制场景，它是场景的核心类，如果能响应键盘时得到viewer，那么也可以从键盘的响应中控制整个场景。viewer中有一个方法，名为addEventHandler就是专门做这件事情的。他会加入一个事件处理器。于是我们就想，一定要自己写一个事件处理器才行，这就必须要了解事件处理器的格式，只要有一个接口就可以了解它的格式，这个接口就是：osgGA::GUIEventHandler，于是我们可以写一个类A从该类公有派生出来，即：class A：public osgGA::GUIEventHandler,在里面处理好各种操作然后加入到viewer当中，即：viewer.addEventHadler(new A(里面可以有参数));这样就可以完成操作。</p>
<p>假如类A是一个事件处理类，那么加入类A可以这样理解，如图3.5：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL2NoczFELnBuZw==.jpg"></p>
<p>图 35事件A控制场景过程</p>
<p> </p>
<h3>1.5.2 事件类型与响应</h3>
<p>代码                 值         　　 事件类型</p>
<p>NONE               0             　　 无事件。</p>
<p>PUSH                 1　　　　　　 鼠标某键按下，在上面代码28行有用到。</p>
<p>RELEASE     　　 2 　　　　　　鼠标某键弹起。</p>
<p>DOUBLECLICK  　4　　　　　　 鼠标某键双击。</p>
<p>DRAG   　　　　  8 　　　　　　鼠标某键拖动。</p>
<p>MOVE 　　　　　16　　　　　　 鼠标移动。</p>
<p>KEYDOWN 　　 32 　　　　　　键盘上某键按下。</p>
<p>KEYUP 　　　　 64 　　　　　　键盘上某键弹起。</p>
<p>FRAME  　　　　128　　　　 应该是鼠标每帧。没用过。</p>
<p>RESIZE 　　　　 256 　　　　窗口大小改变时会有的事件。</p>
<p>SCROLL  　　　　512　　　　 鼠标轮滚动。</p>
<p>PEN_PRESSURE  1024 　　　　手写板的某事件？</p>
<p>PEN_PROXIMITY_ENTER  2048 　　手写板的某事件？</p>
<p>PEN_PROXIMITY_LEAVE   4096 　　手写板的某事件？</p>
<p>CLOSE_WINDOWS 　　 8192 　　关闭窗口。</p>
<p>QUIT_APPLICATION  　　16384 　　退出程序。</p>
<p>USER  　　　　　　　　　32768　　 用户定义。</p>
<p>至于为什么都用2的N次方，主要是因为它的二进制编码只有一位是一，判断事件时很好判断，只要年哪位是一就可以了。</p>
<h3>1.5.3 PICK</h3>
<p>pick主要是通过鼠标的点击来拾取一些物体，或者判断鼠标所点击的位置在哪里。Pick实现的思路如下图所示：</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL3BWUzIxLnBuZw==.jpg"></p>
<p> </p>
<p>图 36pick事件流程</p>
<p>判断射线与viewer中物体相交的方法为发出射线并相交。在OSG中有库函数，osgViewer::View::computeIntersections他共有三个参数：第一个是x屏幕坐标，第二个是Y屏幕坐标，第三个是存放被交的结点以及相交的坐标结点路径等等相关信息。</p>
<p>判断相交结点为我想要的那个结点：只需要判断存放相交射线交场景的结果集中有没有要用的结点就可以了。</p>
<p> </p>
<h2>1.6 漫游</h2>
<h3>1.6.1 MatrixManipulator</h3>
<p>场景的核心管理器是viewer，而漫游必须响应事件，比如鼠标动了，场景也在动。响应事件的类是osgGA::GUIEventHandler。我们想把响应事件的类派生一个新类出来，这个类专门用来根据响应控制viewer。这个类就是osgGA::MatrixManipulator，这个类有一些设置矩阵的公共接口，有了这些接口就可以有效的控制viewer了，根据不同的习惯，大家还会设置不同的控制方式，如同OSG自带的几个操作器，操作都不尽相同。来看一下漫游的主要流程如图6.1：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL0pFSlhxLnBuZw==.jpg"></p>
<p>图 37一般的场景操作器</p>
<p>操作器必须从osgGA::MatrixManipulator派生而来。osgGA::MatrixManipulator有四个可以控制场景的重要接口：</p>
<pre><code>1 virtual void setByMatrix(const osg::Matrixd&amp;matrix)=0
2
3  virtual void setByInverseMatrix(const osg::Matrixd&amp;matrix)=0
4
5  virtual osg::Matrixd getMatrix()const=0
6
7  virtual osg::Matrixd getInverseMatrix()const=0
8  </code></pre>
<p>四个矩阵接口可以有效的向viewer来传递矩阵的相关信息。</p>
<h3>1.6.2 碰撞检测</h3>
<p>最简单的碰撞检测如下图所示：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tLzZiTUZZLnBuZw==.jpg"></p>
<p>图 38简单的碰撞检测原理图</p>
<p>TravelManipulator.dll中用到的就是如图所示的原理，黑三角形代表没有移动之的位置，控制移动的函数是ChangePosition(osg::Vec3&amp;delta)，参数意思是要移动的相对于当前点的增量，在黑三角形没有移动时该函数在计算时先假设一点newPosition为移动后的点，而后通过连接这两个点，而后通过判断与场景的模型是否有交点来判定这个移动可不可以执行，如图所示，两者之间有个大盒子，是穿不过去的，所以只有保持在原地。就算没有这个盒子，移动后的新点又与地面在某种程序上有一个交点，这证明移动是不可行的。这可以防止用户穿过地板到达地下去。</p>
<h3>1.6.3 路径漫游</h3>
<p>使用path文件的方法如下面示例</p>
<pre><code>1 #include&lt;osgDB/ReadFile&gt;
 2
 3 #include&lt;osgViewer/Viewer&gt;
 4
 5 #include&lt;osg/Node&gt;
 6
 7 #include&lt;osgGA/AnimationPathManipulator&gt;
 8
 9  void main()
10
11 {
12
13 osgViewer::Viewer viewer;
14
15 viewer.setSceneData(osgDB::readNodeFile("glider.osg"));
16
17  //申请一个操作器，参数为一个path文件。
18
19 osg::ref_ptr&lt;osgGA::AnimationPathManipulator&gt;amp=new osgGA::AnimationPathManipulator("glider.path");
20
21  //选择使用这个操作器。
22
23 viewer.setCameraManipulator(amp.get());
24
25 viewer.realize();
26
27 viewer.run();
28
29 }
30
31  </code></pre>
<p>我们可以用路径编辑器编辑path文件，或者可以控制程序中的某个物体的运动轨迹然后保存为path文件。</p>
<h2>1.7 更新&amp;回调</h2>
<p>回调的意思就是说，你可以规定在某件事情发生时启动一个函数，这个函数可能做一些事情。这个函数就叫做回调函数，我们可以使用已有回调函数或者自定义回调函数。</p>
<p>Ø 使用已有回调</p>
<p>已有的回调的类型有很多种，一般很容易就想到的是UpdateCallBack，或者EventCallBack等</p>
<p>Ø 自定义回调</p>
<p>自定义回调为从一个回调类型派出生自己的回调，然后具有该种回调的特点等等。</p>
<p>NodeVisitor是一个极有用的类，可以访问结点序列，使用的方法大同小异，NodeVisitor的工作流程如下图所示：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL1FzOGFqLnBuZw==.jpg"></p>
<p>图 39NodeVisitor工作流程</p>
<p>在主结点accept之后，结点数据立即传至NodeVisitor中去，应用apply函数，可以将数据定任一些操作，更多的操作还是需要硬性的制做与调用。</p>
<h2>1.8 粒子系统初步</h2>
<p>在OSG中提供有专门的粒子系统工具，名字空间为osgParticle，OSG对经常使用的粒子模拟都做了专门的类，如：ExplosionEffect用于暴炸的模拟，FireEffect用于火的模拟，ExplosionDebrisEffect用于爆炸后四散的颗粒模拟等等。</p>
<p>在OSG中使用粒子系统一般要经历以下几个步骤：</p>
<p>第一步：确定意图（包括粒子的运动方式等等诸多方面）。第二步：建立粒子模版，按所需要的类型确定粒子的角度（该角度一经确定，由于粒子默认使用有Billboard所以站在任何角度看都是一样的），形状（圆形，多边形等等），生命周期等。第三步：建立粒子系统，设置总的属性，第四步：设置发射器（发射器形状，发射粒子的数目变化等），第五步：设置操作（旋转度，风力等等因素）。第六步：加入结点，更新。下图描述了各个部分是协调工作的方式：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL2cydWFvLnBuZw==.jpg"></p>
<p>图 310粒子系统各个部分是协调工作的方式</p>
<p>上图中各个部分所对应的类如下图所示</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1ndXIuY29tL08ybzZsLnBuZw==.jpg"></p>
<p>图 311粒子系统各部分对应的类</p>
<p> </p>
<h2>1.9 视口&amp;LOD&amp;Imposter</h2>
<h3>1.9.1 多视口</h3>
<p>多视口的原理是自己创建所有的相机，包括主相机，这样我们可以随意的添加相机。</p>
<p>首先我们要创建视口必须有以下几件东西，第一，了解整个屏幕的分辩率有多大，这样可以分辩视口的大小，好分割开来。第二，上下文。我们必须自己手动的打开设置上下文。每个视口的数据也不一定非要与主视口的相同。但是矩阵一般是同步的。也就是说：主视口里有栋楼，从视口里可以是平面图什么的。了解整个屏幕的分辩率可以用这个类：osg::GraphicsContext::WindowingSystemInterface意思是说系统接口，可以获得当前环境的各种信息。有一方法叫getScreenResolution，可以得到分辩率。之后上下文了，osg::GraphicsContext里面可以设置窗口大小，缓存什么的，大多数的东西都在这里面设置。</p>
<h3>1.9.2 LOD</h3>
<p>LOD即level of details</p>
<p>LOD比起PagedLOD而言并非十分的常用，有个地方用的特别多，那就是把一个好好的模型加一个视矩压成一个模型，这个模型比以前的看来就是多了个视矩的控制，远了看不见，近了能看见。</p>
<p>在模型中加LOD头结点的方式如下所示：</p>
<pre><code>1 #include&lt;osgDB/Registry&gt;
 2
 3 #include&lt;osgDB/ReadFile&gt;
 4
 5 #include&lt;osgDB/ReaderWri ter&gt;
 6
 7 #include&lt;osgDB/Wri teFile&gt;
 8
 9 #include&lt;osg/Node&gt;
10
11 #include&lt;osgViewer/Viewer&gt;
12
13  int main()
14
15 {
16
17 osgViewer::Viewer viewer;
18
19  //读取模型
20
21 osg::Node*node=osgDB::readNodeFile("fountain.osg");
22
23  //隐藏结点
24
25 node-&gt;asGroup()-&gt;getChild(0)-&gt;setNodeMask(0);
26
27 viewer.setSceneDa ta(node);
28
29  //输出结点到free.os g中
30
31 osgDB::writeNodeFile(*(viewer.getSceneData()),"free.osg",osgDB::Registry
32
33 ::instance()-&gt;getOptions());
34
35  return 0;
36
37 }
38
39
</code></pre>
<p>1.9.3 Imposter</p>
<p>用动态图片来替换场景的实用技术：imposter.可以把它法做LOD一样使用，只不过它</p>
<p>不是变模型变没有，而是使它换成一张图</p>
<p>示例代码如下：设置一个视矩，超过这个视距模型会变为一张动态图</p>
<pre><code>1 #include&lt;osgViewer/Viewer&gt;
 2
 3 #include&lt;osgGA/TrackballManipulator&gt;
 4
 5 #include&lt;osgSim/Impostor&gt;
 6
 7 #include&lt;osgDB/ReadFile&gt;
 8
 9  int main(inta rgc,cha r**a rgv)
10
11 {
12
13  //申请viewer
14
15 osgViewer::Viewer viewer;
16
17  //读取模型
18
19 osg::Node*node=osgDB::readNodeFile("ceep.ive");
20
21  //申请一个i mpos tor结点
22
23 osgSim::Impos tor*sim=new osgSim::Impostor;
24
25 //在到之内显示模型，之外显示贴图
26
27 sim-&gt;addChild(node,0,50000);
28
29 sim-&gt;setImpostorThreshold(1000);
30
31 osg::Group*root=new osg::Group;
32
33 root-&gt;addChild(sim);
34
35 viewer.setSceneData(root);
36
37 viewer.realize();
38
39 viewer.run();
40
41 return 0;
42
43 }
44
45 </code></pre>
<p>1.10 文字&amp;模型阴影</p>
<h3>1.10.1 HUD </h3>
<p>HUD即head up display</p>
<p>文字在3D场景中显示往往要经历以下几步：读取字体点阵信息-&gt;转化为图像-&gt;反走样-&gt;最终图像。在反走样期间可以处理可种模糊效果，在最终图像形成时可以设置如何摆放。OSG中有一个TEXT类，提供可很多文字显示的方法，比如</p>
<pre><code>void setFont(Font*font=0)

//设置/得到字体，如setFont("fonts/SIMYOU.TTF");

void setFont(const std::string&amp;fontfile)

const Font*getFont()const

//设置/得到字体显示的宽高

void setFontResolution(unsigned int width,unsigned int height)

unsigned int getFontWidth()const

unsigned int getFontHeight()const

//设置/得到文字的具体内容</code></pre>
<p>等等，可以很方便的调用</p>
<h3>1.10.2 阴影</h3>
<p>OSG对阴影的支持也相当的好，可以很容易的写出简单的阴影效果，可以参考例子osgShadow</p>
<p>OSG有一个专门的shadow类来支持阴影效果，提供了很多接口，如：</p>
<pre><code>1 void setBackdropType(BackdropType type)
 2
 3 //说明：设置阴影类型。
 4
 5 void setBackdropOffset(float offset=0.07f)
 6
 7 void setBackdropOffset(float horizontal,float vertical)
 8
 9 //说明：设置阴影的离开程度与方向
10
11 void setBackdropColor(const osg::Vec4&amp;color)
12
13 //说明：设置阴影颜色
14
15 void setColorGradientMode(ColorGradientMode mode)
16
17 //说明：设置颜色映射方式，可以得到渐变效果
18 </code></pre>
<p>等等</p>
<p> </p>
<p>PS：本文为几个月前整理，参考书：FreeSouth的《QpenSceneGraph程序设计》</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:55:08</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>OSG开发概览的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGOQez.html" rel="bookmark">Java web应用开发概览（转贴）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web Web开发(Web Development)是JBuilder Professional 和 Enterprise版权的特性. Applet 开发是 JBuilder所有版本开发的一个特性.本节介绍了web开发技术.包含了他们的异同点.讨论了如何决定使用何种技术.我们首先介绍这些技术的概念. Web应用程序技术 技术描述 Applets 一种可以被浏览器下载并在浏览器上运行的Java小应用程序. Servlets 可以处理客户请求的运行在服务器端的Java应用程序. JavaServer			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd6qBmb.html" rel="bookmark">iOS开发系列--IOS程序开发概览</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概览 终于到了真正接触IOS应用程序的时刻了,之前我们花了很多时间去讨论C语言.ObjC等知识,对于很多朋友而言开发IOS第一天就想直接看到成果,看到可以运行的IOS程序.但是这里我想强调一下,前面的知识是你日后开发IOS的基础,没有那些知识你开发IOS会很痛苦,现在很多开发人员做开发都是一知半解,程序质量确实令人担忧,所以还是希望大家能够熟练掌握前面的内容,开发过程中多思考,彻底理解程序运行的原理.机制.好了言归正传,不管怎么样正式进入IOS开发还是令人兴奋的,今天的内容虽然说是开发预览,其实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bam6Gnb.html" rel="bookmark">iOS开发系列--并行开发其实很容易</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概览 大家都知道,在开发过程中应该尽可能减少用户等待时间,让程序尽可能快的完成运算.可是无论是哪种语言开发的程序最终往往转换成汇编语言进而解释成机器码来执行.但是机器码是按顺序执行的,一个复杂的多步操作只能一步步按顺序逐个执行.改变这种状况可以从两个角度出发:对于单核处理器,可以将多个步骤放到不同的线程,这样一来用户完成UI操作后其他后续任务在其他线程中,当CPU空闲时会继续执行,而此时对于用户而言可以继续进行其他操作:对于多核处理器,如果用户在UI线程中完成某个操作之后,其他后续操作在别的线程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeood0M.html" rel="bookmark">iOS开发系列--让你的应用&OpenCurlyDoubleQuote;动&rdquo;起来</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概览 在iOS中随处都可以看到绚丽的动画效果,实现这些动画的过程并不复杂,今天将带大家一窥iOS动画全貌.在这里你可以看到iOS中如何使用图层精简非交互式绘图,如何通过核心动画创建基础动画.关键帧动画.动画组.转场动画,如何通过UIView的装饰方法对这些动画操作进行简化等.在今天的文章里您可以看到动画操作在iOS中是如何简单和高效,很多原来想做但是苦于没有思路的动画在iOS中将变得越发简单: CALayer CALayer简介 CALayer常用属性 CALayer绘图 Core Animat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlxLG8M.html" rel="bookmark">用OSG结合数据库实现三维地理信息动态Map管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 用OSG结合数据库实现三维地理信息动态Map管理或者参看: 解决方案 解决方案二:总体界面数据库路网自动寻路解决方案三:自己做的3DOSG漫游仿真地理信息系统调用3D模型解决方案四:楼主强大,多谢分享!解决方案五:利用OSG的三维特性,还可对数据库数据实现统计绘图(直方图.圆饼图)解决方案六:在3维的地理信息系统中,还可以添加自己实现的自己实现的粒子特效:包括:雨.火.烟解决方案七:三维环境下的目标物体追踪(可以打开独立小窗口观察)解决方案八:平台源码出售源码有限制吗?绝对没有是全部的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YqGgM.html" rel="bookmark">动画</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概览 在iOS中随处都可以看到绚丽的动画效果,实现这些动画的过程并不复杂,今天将带大家一窥iOS动画全貌.在这里你可以看到iOS中如何使用图层精简非交互式绘图,如何通过核心动画创建基础动画.关键帧动画.动画组.转场动画,如何通过UIView的装饰方法对这些动画操作进行简化等.在今天的文章里您可以看到动画操作在iOS中是如何简单和高效,很多原来想做但是苦于没有思路的动画在iOS中将变得越发简单: CALayer CALayer简介 CALayer常用属性 CALayer绘图 Core Animat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvr0KaM.html" rel="bookmark">Xcode文档安装</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本小节知识点: Xcode文档在线安装 Xcode文档离线安装 Xcode文档基本使用 如何阅读文档? 作为独立开发者,你还能干什么? 1.Xcode文档在线安装 打开Xcode,首选项 点击DownLoads下载文档 图片 2.Xcode文档离线安装 找到备份的文档 com.apple.adc.documentation.AppleiOS8.0.iOSLibrary.docset 图片:images/a9/Snip20150529_4.png) 找到DocSets目录 /Application			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXB0kQb.html" rel="bookmark">Windows Phone 8&period;1 开发技术概览 （Universal APP）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前一阵真的比较懒 WP8.1 已经出来这么长时间了现在才更新BLOG让大家久等了,今天我先为大家介绍下 WP 8.1的开发框架,什么是微软所推崇的 Universal APP,以及我们要开发 Universal APP的时候要注意哪些内容. 如果是您是一个刚刚接触 WP开发的朋友可以先看下我之前的文章了解一下故事背景:Windows Phone 8 与 windows 8 开发技术概览 首先给大家完善一个概念 - 那就是 Windows Phone 8.1 和 Windows Phone 8.0			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balanXz.html" rel="bookmark">Windows 8风格应用开发入门 七 页面视图概览</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Windows 8风格应用中包含哪些视图 常用的几种视图包括: 开发入门 七 页面视图概览-页面视图&quot;&gt; 1. FullScreenLandscape(水平方向全屏视图) 2. Filled(填充视图) 3. Snap view(贴靠视图) 4. FullScreenPortrait(竖直方向全屏视图) 最小视图状态分辨率支持1024*768,全屏视图状态分辨率为1366*768以上. 注意:实现贴靠视图的最小分辨率为1366*768. Visual Studio 2012和模拟器中如何开			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdy96z.html" rel="bookmark" class="title">phpexcel图乱码-无人能解。。phpexcel生成饼状图，在Windows下正常在Linux下乱码！</a>
					<div>
						问题描述 无人能解..phpexcel生成饼状图,在Windows下正常在Linux下乱码! 生成图片导出时,在Windows下整成显示,在Linux上导出的文件里只有乱码 但如果只生成表格,都可以正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyKd8z.html" rel="bookmark" class="title">中断处理程序不能使用printf的本质</a>
					<div>
						vxworks 中断处理程序之所以不用printf,本质在于printf是将信息输出到标准输出设备(STDOUT)中, 整个标准输出设备是一个全局变量,由于有semTake操作,那么就会发生阻塞,vx ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M03omb.html" rel="bookmark" class="title">对权限控制又很深入的讨论&lpar;2&rpar;</a>
					<div>
						控制 Re: 我也请教一个关于权限设计方面的问题 发表时间: 2003年10月24日 16:24:18 回复 发表人: littlebird 发表文章: 1 / 注册时间: 2003-10 看了这么多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR0Jxz.html" rel="bookmark" class="title">八款个人网络防火墙主要功能介绍</a>
					<div>
						[导读]网络如江湖,到处暗藏着杀机,稍不小心就会中招.安装一款个人网络防火墙,可以降低受到攻击的威胁,让你放心网海冲浪. 防火墙简介 防火墙的本义原是指古代人们房屋之间修建的那道墙,这道墙在火灾发生时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Nq97z.html" rel="bookmark" class="title">Oracle数据库安全之Oracle标签安全（OLS）</a>
					<div>
						在上一篇文章中讨论了如何利用VPD对Oracle表中的行进行访问控制(见&lt;[Oracle] 数据 库安全之 - 虚拟私有数据库 (VPD)&gt;),下面介绍一种比VPD复杂一点的访问控制技术- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK348p.html" rel="bookmark" class="title">应该如何编写高质量的Objective-C代码</a>
					<div>
						  点标记语法 属性和幂等方法(多次调用和一次调用返回的结果相同)使用点标记语法访问,其他的情况使用方括号标记语法. 良好的风格: view.backgroundColor = [UIColor or ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91rVkM.html" rel="bookmark" class="title">PS唯美海滩人像制造法</a>
					<div>
						夏天.美女.海滩.黄昏时分,组成了一幅唯美的景象,可是拍出来却不尽如人意,画面总是显得暗淡.虽然模特穿的色彩缤纷,却总是差了点味道,现在小编就来帮你解决这个问题,有请本期嘉宾:JOJO 看他如何通过P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1kYEz.html" rel="bookmark" class="title">如何安装邮件服务器</a>
					<div>
						点击开始菜单设置-控制面板 点击添加或删除程序 点击添加/删除windows组件(A)找到电子邮件服务双击进去 进来之后2个都选择打勾 最后等待安装好就可以了. 本文由资源美技巧网原创发布,转载请保留 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3KL8M.html" rel="bookmark" class="title">codeigniter自带数据库类使用方法说明</a>
					<div>
						 在 CodeIgniter 中,使用数据库是非常频繁的事情.你可以使用框架自带的数据库类,就能便捷地进行数据库操作 初始化数据库类   依据你的数据库配置载入并初始化数据库类:   代码如下: th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eenYb.html" rel="bookmark" class="title">Excel表格之建立分类下拉列表填充项</a>
					<div>
						  Excel表格要做出下拉填充项是需要方法的,而我们又经常会用到,所以今天就教大家怎么做吧.我们常常要将企业的名称输入到Excel表格中,为了保持名称的一致性,利用&quot;数据有效性&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNk1OM.html" rel="bookmark" class="title">打开网站提示&OpenCurlyDoubleQuote;此网站的安全证书有问题&rdquo;怎么办</a>
					<div>
						上网使用ie7或者ie8访问某些网站时出现:&quot;此网站的安全证书有问题&quot;的警告提示,是网站的问题吗,如何解决? 简单的说,出现此问题多是因为网站内容使用了特殊的脚本程序和未经微软认证 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXNaXp.html" rel="bookmark" class="title">Win8系统下如何取消IE浏览器的连接下划线</a>
					<div>
						  现在win8系统中一般都有自带IE10浏览器,IE10浏览器的功能上也有很大的改进,但是有些用户则希望能够将IE浏览器显示的链接下划线取消掉,虽然可以通过清除缓存来解决,但是每次要清除太麻烦了,其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3vaBM.html" rel="bookmark" class="title">提升网站用户体验&mdash;WebP 图片的高效使用</a>
					<div>
						一.WebP 的由来 现代图像压缩技术对我们的生活方式影响很大.数码相机能将上千张高质量图片存储到一张内存卡里.智能手机可以与邻近设备快速分享高分辨率的图片.网站与手机等移动设备能快速展示各种富媒体. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywRP8z.html" rel="bookmark" class="title">浅析数据结构中栈与C实现</a>
					<div>
						最近在搞摄像头驱动,o()︿︶)o 唉,别提有多烦,一堆寄存器就有人受的了--特么这不是单片机的开发,这是内核驱动开发-- 今天放松一下,我们来看看数据结构中的栈,这节的知识点可以说是数据结构中最容易 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWJ9jb.html" rel="bookmark" class="title">Android深入浅出之Binder机制&lowbar;Android</a>
					<div>
						Android深入浅出之Binder机制 一 说明  Android系统最常见也是初学者最难搞明白的就是Binder了,很多很多的Service就是通过Binder机制来和客户端通讯交互的.所以搞明白 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAqDZM.html" rel="bookmark" class="title">跟屌丝学设计模式之责任链模式</a>
					<div>
						JAVA之责任链模式 原文地址:http://itzyx.com/index.php/java_zrl/ 在阎宏博士的&lt;JAVA与模式&gt;一书中开头是这样描述责任链(Chain of Res ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrynwM.html" rel="bookmark" class="title">聊天记录，时间戳1435388817088 转换后，时间是47455&sol;8&sol;30 19&colon;51&colon;28   怎么回事。</a>
					<div>
						问题描述 解决方案 好像多了三位?解决方案二:我少 /1000 了..解决方案三:是的,时间戳是毫秒,要除以1000转成秒以后再行计算.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6kGoM.html" rel="bookmark" class="title">图书馆图书查找功能~~~我想问下这个函数有没有哪里错~我是渣渣</a>
					<div>
						问题描述 图书馆图书查找功能~~~我想问下这个函数有没有哪里错~我是渣渣 #include &quot;bookrecord.h&quot; void search( BOOK *top){ char ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAZ6vp.html" rel="bookmark" class="title">SpringBoot优化内嵌的Tomcat ---设置MaxConnections</a>
					<div>
						使用kill -9杀掉springboot应用后,立马java -jar重启,会报错,需要等待一段时间才能启动成功,报错的原因是:/tmp/tomcat-docbase.474979491043437 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZRDWz.html" rel="bookmark" class="title">SpringMVC后台action取不到页面参数</a>
					<div>
						问题描述 试了好久,当页面输入框有name属性的时候,后台action可以取到参数值:但是页面输入框只有id属性,而没有name属性的时候,后台怎么也取不到参数值,无论是从request对象取还是直接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZO8AM.html" rel="bookmark" class="title">Google毁了Web？</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 Google 太强大了.搜索引擎不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod7O3M.html" rel="bookmark" class="title">这些新兴IT角色是不是你的菜？</a>
					<div>
						IT从成本中心逐渐转变为服务中心.如今我们对IT行业关注度这么高,同时也反映出我的一些期望:IT行业为公司提供一些可衡量的价值.许多新型IT功能我们似乎非常熟悉,根据一些例子我们可以追根溯源,建立起一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZ8jlp.html" rel="bookmark" class="title">thinkphp-Thinkphp框架下，验证码问题</a>
					<div>
						问题描述 Thinkphp框架下,验证码问题 public function myses(){ import(&quot;ORG.Util.Date&quot;); $Setime=session(' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK58kdp.html" rel="bookmark" class="title">数据库获取字段mfc-如何从数据库字段获取uniqueidentifier</a>
					<div>
						问题描述 如何从数据库字段获取uniqueidentifier MFC获取uniqueidentifier类型的字段会有{}大括号,这样用这个字段得到的值查询数据就会出错.语法错误,如何把大括号去掉, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRelop.html" rel="bookmark" class="title">突然想到一个问题</a>
					<div>
						问题描述 WPF中TextBox绑定double类型的时候,正常输入时小数点输入不进去:这个问题怎么解决? 解决方案 解决方案二:我是被标题吸引进来的解决方案三:可以输入的.放点代码看看,中文的小数点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xVPRb.html" rel="bookmark" class="title">玩出C&amp;amp&semi;C服务器地址隐身的新花样，看看这个恶意软件怎么做的</a>
					<div>
						恶意软件作者们一直在凭借自己天马行空的想法,艰难地绕过安全研究人员的追踪和检测. Palo Alto Network公司就曾在两个独立无关的网络间谍事件中,检测到这样的后门木马样本.研究人员表示,在这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0GNOz.html" rel="bookmark" class="title">香港金管局维持利率在0&period;50&percnt;不变</a>
					<div>
						香港金融管理局5日宣布,将基准利率维持在0.50%的水平不变,追随了美联储前夜保持联邦基金目标利率不变的决定. 港元盯住美元的联系汇率制令香港货币政策与美国货币政策相挂钩,因此香港金管局通常紧随美联储 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn80ZOb.html" rel="bookmark" class="title">5种java排序算法汇总工具类&lowbar;java</a>
					<div>
						工具类简单明了地总结了java的快速排序,希尔排序,插入排序,堆排序,归并排序五种排序算法,代码中并没有对这几种排序算法的一个说明,关于思想部分希望在自行查阅相关说明,这里只是对这几种算法进行一个概括 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYmJnb.html" rel="bookmark" class="title">什么是JavaScript注入攻击&quest;&lowbar;javascript技巧</a>
					<div>
						Javascript可以作为黑客攻击网站的一种工具,其中注入js(javascript)恶意脚本就是其中一种手段之一,那么下面,大家来学习一下如何预防js的注入攻击呢?以下有一个不错的陈述,跟大家分享 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1XrOb.html" rel="bookmark" class="title">GOOGLE优化&colon;提高域名信任度的几个简单方法</a>
					<div>
						相信读者都知道,Google对域名信任度要求越来越高,甚至高到了过分的地步.不过抱怨是没有用的,必须面对现实.从总体上来说,提高域名信任度的根本方法,还是提供好的内容,吸引其他同样有可信度的域名链接向 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.047 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
